#include <iostream>
#include <cstdio>
using namespace std;

unsigned Field[51][51], N, M, P, paratroopersCount = 0;

struct Animal
{
	unsigned n, m;
	unsigned landX, landY, safetySum;
	unsigned Shape[11][11];
	unsigned factor;
	unsigned minimumSafety;
};
Animal animals[101], paratroopers[101];

void initField()
{
	unsigned i, j;

	cin>>N>>M>>P;
	for (i=0; i<N; i++)
	{
		for (j=0; j<M; j++)
		{
			scanf("%u", &Field[i][j]);
		}
	}
}

void printField()
{
	unsigned i, j;

	for (i=0; i<N; i++)
	{
		for (j=0; j<M; j++)
		{
			printf("%u ", Field[i][j]);
		}
		printf("\n");
	}
	printf("\n");
}

void initAnimals()
{
	unsigned i, n, m;

	for (i=0; i<P; i++)
	{
		scanf("%u", &animals[i].n); //r
		scanf("%u", &animals[i].m); //c
		scanf("%u", &animals[i].factor); //k
		scanf("%u", &animals[i].minimumSafety); //t

		char shape_part[animals[i].m];

		for (n=0; n<animals[i].n; n++)
		{
			scanf("%s", &shape_part);

			for (m=0; m<animals[i].m; m++)
			{
				animals[i].Shape[n][m] = (int)shape_part[m] - 48;
			}
		}
	}
}

void printAnimals()
{
	unsigned i, n, m;

	for (i=0; i<P; i++)
	{
		printf("%u %u\n", animals[i].factor, animals[i].minimumSafety);

		for (n=0; n<animals[i].n; n++)
		{
			for (m=0; m<animals[i].m; m++)
			{
				printf("%u ", animals[i].Shape[n][m]);
			}
			printf("\n");
		}
		printf("\n");
	}
	printf("\n");
}

unsigned calculateSafety(Animal animal, unsigned i, unsigned j)
{
	unsigned n, m, safety=0;
	bool flag = false;

	for (n=0; n<animal.n; n++)
	{
		for (m=0; m<animal.m; m++)
		{
			if (animal.Shape[n][m])
			{
				if (Field[i + n][j + m] >= animal.minimumSafety)
				{
					safety += Field[i + n][j + m];
				}
				else
				{
					safety = 0;
					flag = true;
					break;
				}
			}
		}

		if (flag) break;
	}

	return safety;
}

void makeFieldParsed(Animal animal, unsigned i, unsigned j)
{
	unsigned n, m;

	for (n=0; n<animal.n; n++)
	{
		for (m=0; m<animal.m; m++)
		{
			if (animal.Shape[n][m])
			{
				Field[i + n][j + m] /= animal.factor;
			}
		}
	}
}

void parseField()
{
	unsigned k, i, j, currentSafety, maxSafetyX, maxSafetyY, maximumSafety;
	Animal animal;

	for (k=0; k<P; k++)
	{
		animal = animals[k];
		maxSafetyX = maxSafetyY = maximumSafety = 0;
		unsigned SafetyField[51][51];

		for (i=0; i<N; i++)
		{
			if (N - animal.n >= i)
			{
				for (j=0; j<M; j++)
				{
					if (M - animal.m >= j)
					{
						//cout<<Field[i][j]<<" ";
						currentSafety = calculateSafety(animal, i, j);

						SafetyField[i][j] = currentSafety;

						if (currentSafety > maximumSafety)
						{
							maximumSafety = currentSafety;
							maxSafetyX = i;
							maxSafetyY = j;
						}
					}
				}
				//cout<<endl;
			}
		}

		if (maximumSafety > 0)
		{
			makeFieldParsed(animal, maxSafetyX, maxSafetyY);
			animal.landX = maxSafetyX;
			animal.landY = maxSafetyY;
			animal.safetySum = SafetyField[maxSafetyX][maxSafetyY];
			paratroopers[paratroopersCount++] = animal;

			//printf("%u %u %u\n", paratroopersCount, maxSafetyX+1, maxSafetyY+1);
			//printField();
		}
	}
}

void printResult()
{
	unsigned i;

	printf("%u\n", paratroopersCount);

	for (i=0; i<paratroopersCount; i++)
	{
		Animal animal = paratroopers[i];
		printf("%u %u %u\n", i+1, animal.landX+1, animal.landY+1);
	}
}

int main()
{
	initField();
	initAnimals();
	//printField();
	//printAnimals();
	parseField();
	printResult();

	return 0;
}